const puppeteer = require('puppeteer');
// const { screenshot } = require('./config/defaultConfig');
const { imgDir } = require('./config/defaultConfig');
const srcToImg = require('./helper/srcToImg');
// (async () => {
//     const browser = await puppeteer.launch();
//     const page = await browser.newPage();
//     await page.goto('https://www.baidu.com');
//     await page.screenshot({
//         path:`${screenshot}/${Date.now()}.png`
//     });
//     await browser.close();
// })();

(async () => {
    let targetUrl = 'https://image.baidu.com/';
    let keyWord = '美女';
    const browser = await puppeteer.launch();
    const page = await browser.newPage();
    await page.goto(targetUrl);
    console.log(`go to ${targetUrl}`);

    //设置较大的视口，可以获取更多的图片，因为百度图片是懒加载
    await page.setViewport({
        width:1920,
        height:1080
    });
    console.log('reset viewport');

    //模拟输入框聚焦
    await page.focus('#kw');
    await page.keyboard.sendCharacter(keyWord);
    await page.click('.s_search');
    console.log('go to search list');

    //等待搜索列表页
    page.on('load',async() => {
        console.log('page loading done,start fetch...');

        const srcRes = await page.evaluate(()=>{
            const images = document.querySelectorAll('img.main_img');
            return Array.prototype.map.call(images,img => img.src);

        });
        console.log('******',srcRes,'*****');
        srcRes.forEach(async(src) => {
            await page.waitFor(300);
            await srcToImg(src,imgDir);
        });

        await browser.close();
    })

})();